<i18n>
{
  "fr": {
    "label-1": "Modes (t eCO2)",
    "label-2": "Modes (km)",
    "label-3": "Motifs (t eCO2)",
    "label-4": "Motifs (km)",
    "label-5": "Emissions cumulées (%)",
    "label-6": "% des émissions totales cumulées",
    "label-7": "missions représentent"
  },
  "en": {
    "label-1": "Modes (t CO2e)",
    "label-2": "Modes (km)",
    "label-3": "Purposes (t CO2e)",
    "label-4": "Purposes (km)",
    "label-5": "Cumulative emissions (%)",
    "label-6": "% of total cumulative emissions",
    "label-7": "travels represent"
  }
}
</i18n>

<template>
  <div>
    <b-tabs class="block">
      <b-tab-item icon="bar-chart" :label="$t('label-5')">
        <br />
        <highcharts :options="sortedEmissionsOptions" />
      </b-tab-item>
      <b-tab-item icon="bar-chart" :label="$t('label-1')" v-if="hasStatusOption">
        <br />
        <highcharts-column
          ref="travelsStatusCI"
          :categories="transportations"
          :yAxisTitle="$t('emissions.t.co2e.short')"
          :valueSuffix="$t('t.co2e')"
          :valueDecimals="2"
        ></highcharts-column>
        <br />
        <results-table
          :data="emissionsProStatuts"
          :columns="columnsModes()"
        ></results-table>
      </b-tab-item>
      <b-tab-item icon="bar-chart" :label="$t('label-2')" v-if="hasStatusOption">
        <br />
        <highcharts-column
          ref="travelsStatusD"
          :categories="transportations"
          :yAxisTitle="$t('distances.km')"
          :valueSuffix="$t('km')"
        ></highcharts-column>
        <br />
        <results-table
          :data="distancesProStatuts"
          :columns="columnsModes()"
        ></results-table>
      </b-tab-item>
      <b-tab-item icon="bar-chart" :label="$t('label-3')" v-if="!hasStatusOption && hasPurposeOption">
        <br />
        <highcharts-column
          ref="travelsPurposesCI"
          :categories="purposes"
          :yAxisTitle="$t('emissions.t.co2e.short')"
          :valueSuffix="$t('t.co2e')"
          :valueDecimals="2"
        ></highcharts-column>
        <br />
        <results-table
          :data="emissionsProMotifs"
          :columns="columnsMotifs(false)"
        ></results-table>
      </b-tab-item>
      <b-tab-item icon="bar-chart" :label="$t('label-4')" v-if="!hasStatusOption && hasPurposeOption">
        <br />
        <highcharts-column
          ref="travelsPurposesD"
          :categories="purposes"
          :yAxisTitle="$t('distances.km')"
          :valueSuffix="$t('km')"
        ></highcharts-column>
        <br />
        <results-table
          :data="distancesProMotifs"
          :columns="columnsMotifs(false)"
        ></results-table>
      </b-tab-item>
      <b-tab-item icon="bar-chart" :label="$t('label-3')" v-if="hasStatusOption && hasPurposeOption">
        <br />
        <highcharts-column
          ref="travelsStatusPurposesCI"
          :categories="purposes"
          :yAxisTitle="$t('emissions.t.co2e.short')"
          :valueSuffix="$t('t.co2e')"
          :valueDecimals="2"
        ></highcharts-column>
        <br />
        <results-table
          :data="emissionsProStatutsMotifs"
          :columns="columnsMotifs()"
        ></results-table>
      </b-tab-item>
      <b-tab-item icon="bar-chart" :label="$t('label-4')" v-if="hasStatusOption && hasPurposeOption">
        <br />
        <highcharts-column
          ref="travelsStatusPurposesD"
          :categories="purposes"
          :yAxisTitle="$t('distances.km')"
          :valueSuffix="$t('km')"
        ></highcharts-column>
        <br />
        <results-table
          :data="distancesProStatutsMotifs"
          :columns="columnsMotifs()"
        ></results-table>
      </b-tab-item>
    </b-tabs>
  </div>
</template>

<script>
import HighchartsColumn from '@/components/carbon/results/utils/HighchartsColumn.vue'
import ResultsTable from '@/components/carbon/results/utils/ResultsTable.vue'
import Travel from '@/models/carbon/Travel.js'
import '@/plugins/highcharts.js'

export default {
  name: 'PlotsTravels',
  components: {
    'highcharts-column': HighchartsColumn,
    'results-table': ResultsTable
  },
  props: {
    withContrails: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    transportations: function () {
      let transportations = []
      for (let transportation of Travel.transportations) {
        transportations.push(this.$t(transportation))
      }
      return transportations
    },
    purposes: function () {
      let purposes = []
      for (let purpose of Travel.purposes) {
        purposes.push(this.$t(purpose))
      }
      return purposes
    },
    results: function () {
      return this.$store.getters['travels/results']
    },
    computed: function () {
      return this.$store.getters['travels/computed']
    },
    hasPurposeOption: function () {
      return this.$store.getters['travels/hasPurposeOption']()
    },
    hasStatusOption: function () {
      return this.$store.getters['travels/hasStatusOption']()
    },
    emissionsProStatuts: function () {
      let intensity = Travel.initiStatutsTable(Travel.transportations.length)
      let uncertainty = Travel.initiStatutsTable(Travel.transportations.length)
      let self = this
      Object.keys(this.results.status.intensity).map(function (key) {
        if (self.withContrails) {
          intensity[key] = self.results.status.intensity[key].map(obj => obj.intensitywc)
          uncertainty[key] = self.results.status.intensity[key].map(obj => obj.uncertaintywc)
        } else {
          intensity[key] = self.results.status.intensity[key].map(obj => obj.intensity)
          uncertainty[key] = self.results.status.intensity[key].map(obj => obj.uncertainty)
        }
      })
      return this.formatDataTable(
        intensity,
        this.transportations,
        uncertainty,
        true
      )
    },
    emissionsProMotifs: function () {
      let i = 0
      let obj = {}
      for (let category of this.purposes) {
        if (this.withContrails) {
          obj[category] = Math.round(this.results.purposes.intensity[i].intensitywc) + ' +/- ' + Math.round(this.results.purposes.intensity[i].uncertaintywc)
        } else {
          obj[category] = Math.round(this.results.purposes.intensity[i].intensity) + ' +/- ' + Math.round(this.results.purposes.intensity[i].uncertainty)
        }
        i += 1
      }
      return [obj]
    },
    emissionsProStatutsMotifs: function () {
      let intensity = Travel.initiStatutsTable(Travel.purposes.length)
      let uncertainty = Travel.initiStatutsTable(Travel.purposes.length)
      let self = this
      Object.keys(this.results.statuspurposes.intensity).map(function (key) {
        if (self.withContrails) {
          intensity[key] = self.results.statuspurposes.intensity[key].map(obj => obj.intensitywc)
          uncertainty[key] = self.results.statuspurposes.intensity[key].map(obj => obj.uncertaintywc)
        } else {
          intensity[key] = self.results.statuspurposes.intensity[key].map(obj => obj.intensity)
          uncertainty[key] = self.results.statuspurposes.intensity[key].map(obj => obj.uncertainty)
        }
      })
      return this.formatDataTable(
        intensity,
        this.purposes,
        uncertainty,
        true
      )
    },
    distancesProStatuts: function () {
      return this.formatDataTable(
        this.results.status.distances,
        this.transportations
      )
    },
    distancesProMotifs: function () {
      let i = 0
      let obj = {}
      for (let category of this.purposes) {
        obj[category] = Math.round(this.results.purposes.distances[i])
        i += 1
      }
      return [obj]
    },
    distancesProStatutsMotifs: function () {
      return this.formatDataTable(
        this.results.statuspurposes.distances,
        this.purposes
      )
    },
    sortedEmissionsOptions: function () {
      let allEmissions = {}
      for (let travel of this.results.meta) {
        for (let name of travel.names) {
          let intensity = travel.travelIntensity.intensity
          if (this.withContrails) {
            intensity = travel.travelIntensity.intensitywc
          }
          if (name in allEmissions) {
            allEmissions[name] += intensity
          } else {
            allEmissions[name] = intensity
          }
        }
      }
      const cumulativeSum = ((sum) => (value) => {
        sum += value
        return sum
      })(0)
      allEmissions = Object.keys(allEmissions).map(function (k) { return parseFloat(allEmissions[k]) }).sort(function (a, b) {
        return b - a
      })
      allEmissions = allEmissions.map(cumulativeSum)
      let total = allEmissions[allEmissions.length - 1]
      let fiftyPerc = 0
      for (let emission of allEmissions) {
        let cPerc = (emission / total) * 100
        if (cPerc >= 50) {
          break
        }
        if (fiftyPerc < cPerc) {
          fiftyPerc = cPerc
        }
      }
      let twentyPerc = 0
      for (let emission of allEmissions) {
        let cPerc = (emission / total) * 100
        if (cPerc >= 25) {
          break
        }
        if (twentyPerc < cPerc) {
          twentyPerc = cPerc
        }
      }
      let seventyPerc = 0
      for (let emission of allEmissions) {
        let cPerc = (emission / total) * 100
        if (cPerc >= 75) {
          break
        }
        if (seventyPerc < cPerc) {
          seventyPerc = cPerc
        }
      }
      return {
        chart: {
          type: 'column'
        },
        title: {
          text: ''
        },
        credits: {
          enabled: false
        },
        legend: {
          enabled: false
        },
        xAxis: {
          categories: Array.from(Array(allEmissions.length).keys()).map(val => val + 1)
        },
        tooltip: {
          headerFormat: '<b>{point.key}</b> ' + this.$t('label-7'),
          pointFormat: ' <b>{point.y}</b>' + this.$t('label-6'),
          valueDecimals: 2
        },
        yAxis: {
          max: 100,
          tickInterval: 10,
          title: {
            text: this.$t('label-6')
          },
          plotLines: [
            {
              value: 25,
              color: 'red',
              width: 1,
              dashStyle: 'ShortDash'
            },
            {
              value: 50,
              color: 'red',
              width: 1,
              dashStyle: 'ShortDash'
            },
            {
              value: 75,
              color: 'red',
              width: 1,
              dashStyle: 'ShortDash'
            }
          ]
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          },
          chartOptions: {
            chart: {
              width: 750,
              height: 400
            }
          }
        },
        series: [{
          data: allEmissions.map(val => {
            let y = (val / total) * 100
            let color = null
            if (y === fiftyPerc) {
              color = 'red'
            } else if (y === twentyPerc) {
              color = 'red'
            } else if (y === seventyPerc) {
              color = 'red'
            }
            return {
              y: y,
              color: color
            }
          })
        }]
      }
    }
  },
  methods: {
    columnsModes: function () {
      return this.getColumns(this.transportations)
    },
    columnsMotifs: function (withstatus = true) {
      return this.getColumns(this.purposes, withstatus)
    },
    getColumns: function (table, withstatus = true) {
      let columns = []
      if (withstatus) {
        columns.push({
          'field': this.$t('status'),
          'label': this.$t('status'),
          'sticky': true
        })
      }
      for (let mode of table) {
        columns.push({
          'field': mode,
          'label': this.$t(mode),
          'numeric': true
        })
      }
      return columns
    },
    formatDataTable: function (data, cols, datai = null, intons = false) {
      let toReturn = []
      if (this.computed) {
        for (let statut of Object.keys(data)) {
          let catObject = {}
          let i = 0
          for (let cat of cols) {
            if (datai === null) {
              if (intons) {
                catObject[cat] = this.$options.filters.splitNumberTons(data[statut][i])
              } else {
                catObject[cat] = this.$options.filters.splitNumber(data[statut][i])
              }
            } else {
              if (intons) {
                catObject[cat] = '<nobr>' + this.$options.filters.splitNumberTons(data[statut][i]) + ' +/- ' + this.$options.filters.splitNumberTons(datai[statut][i]) + '</nobr>'
              } else {
                catObject[cat] = '<nobr>' + this.$options.filters.splitNumber(data[statut][i]) + ' +/- ' + this.$options.filters.splitNumber(datai[statut][i]) + '</nobr>'
              }
            }
            i += 1
          }
          catObject[this.$t('status')] = '<nobr>' + this.$t(statut) + '</nobr>'
          toReturn.push(catObject)
        }
      }
      return toReturn
    },
    formatDataChart: function (data, intons = false) {
      let toReturn = []
      for (let statut of Travel.status) {
        if (intons) {
          toReturn.push({
            name: this.$t(statut),
            data: data[statut].map(val => val / 1000)
          })
        } else {
          toReturn.push({
            name: this.$t(statut),
            data: data[statut]
          })
        }
      }
      return toReturn
    },
    formatDataiChart: function (data, datai) {
      let toReturn = []
      for (let statut of Travel.status) {
        toReturn.push({
          data: data[statut].map((obj, i) => {
            return [obj / 1000 - datai[statut][i] / 1000, obj / 1000 + datai[statut][i] / 1000]
          })
        })
      }
      return toReturn
    },
    process: function () {
      if (this.computed) {
        if (this.hasStatusOption) {
          this.$refs.travelsStatusD.setData(
            this.formatDataChart(this.results.status.distances)
          )
          this.$refs.travelsStatusPurposesD.setData(
            this.formatDataChart(this.results.statuspurposes.distances)
          )
          let intensitys = Travel.initiStatutsTable(Travel.transportations.length)
          let uncertaintys = Travel.initiStatutsTable(Travel.transportations.length)
          let self = this
          Object.keys(this.results.status.intensity).map(function (key) {
            if (self.withContrails) {
              intensitys[key] = self.results.status.intensity[key].map(obj => obj.intensitywc)
              uncertaintys[key] = self.results.status.intensity[key].map(obj => obj.uncertaintywc)
            } else {
              intensitys[key] = self.results.status.intensity[key].map(obj => obj.intensity)
              uncertaintys[key] = self.results.status.intensity[key].map(obj => obj.uncertainty)
            }
          })
          this.$refs.travelsStatusCI.setData(
            this.formatDataChart(
              intensitys,
              true
            ),
            this.formatDataiChart(
              intensitys,
              uncertaintys
            )
          )
          let intensityp = Travel.initiStatutsTable(Travel.purposes.length)
          let uncertaintyp = Travel.initiStatutsTable(Travel.purposes.length)
          Object.keys(this.results.statuspurposes.intensity).map(function (key) {
            if (self.withContrails) {
              intensityp[key] = self.results.statuspurposes.intensity[key].map(obj => obj.intensitywc)
              uncertaintyp[key] = self.results.statuspurposes.intensity[key].map(obj => obj.uncertaintywc)
            } else {
              intensityp[key] = self.results.statuspurposes.intensity[key].map(obj => obj.intensity)
              uncertaintyp[key] = self.results.statuspurposes.intensity[key].map(obj => obj.uncertainty)
            }
          })
          this.$refs.travelsStatusPurposesCI.setData(
            this.formatDataChart(
              intensityp,
              true
            ),
            this.formatDataiChart(
              intensityp,
              uncertaintyp
            )
          )
        }
        if (!this.hasStatusOption && this.hasPurposeOption) {
          this.$refs.travelsPurposesD.setData([{
            data: this.results.purposes.distances
          }])
          if (this.withContrails) {
            this.$refs.travelsPurposesCI.setData(
              [{
                data: this.results.purposes.intensity.map(obj => obj.intensitywc)
              }],
              [{
                data: this.results.purposes.intensity.map(obj => {
                  return [obj.intensitywc - obj.uncertaintywc, obj.intensitywc + obj.uncertaintywc]
                })
              }]
            )
          } else {
            this.$refs.travelsPurposesCI.setData(
              [{
                data: this.results.purposes.intensity.map(obj => obj.intensity)
              }],
              [{
                data: this.results.purposes.intensity.map(obj => {
                  return [obj.intensity - obj.uncertainty, obj.intensity + this.uncertainty]
                })
              }]
            )
          }
        }
      }
    }
  },
  mounted () {
    if (!this.$store.getters['travels/computed']) {
      this.$store.dispatch('travels/compute')
    }
    this.process()
  }
}
</script>

<style>
.is-sticky {
  background: #fafafa !important;
}
</style>
